<template>
  <div class="main-contain">
    <div class="position">
      <bread-crumb v-if="this.$route.query.type == 1" :crumbs='crumbs'></bread-crumb>
      <bread-crumb v-if="this.$route.query.type == 2" :crumbs='crumbs2'></bread-crumb>
      <div style="float:right;">
        <el-button size="small"  @click="back()" class="filter-item"   >取 消</el-button>
        <el-button size="small"  type="primary" @click="submit()" class="filter-item" >保 存</el-button>
      </div>
    </div>
    <div class="app-container">
      <stock-in-dialog
        ref="dialog" :propForm="propForm"
        :visibility="isVisibility"
        v-on:dialog-comfirm="comfirm"
        v-on:dialog-cancle="cancle"
      ></stock-in-dialog>
      <div class="cell clearfix">

        <label class="title"><span class="name">退库时间</span> : </label>
        <el-date-picker size="small" v-model="return_time" prefix-icon="el-icon-date" :editable="false" style="width: 196px;"
                        type="date" placeholder="选择日期时间" align="right" format="yyyy-MM-dd"
                        value-format="yyyy-MM-dd"></el-date-picker>
      </div>

      <div class="cell clearfix">
        <label class="title"><span class="name">经销商</span> : </label>
        <el-select   size="small"  v-model="form.dealer" clearable  placeholder="请选择经销商"  @change="changeDealer">
          <el-option
            v-for="(option, index) in dealer"
            :key="index"
            :label="option.dealer_name"
            :value="option.id">
          </el-option>
        </el-select>
      </div>

      <div class="cell clearfix">
        <label class="title"><span class="name">厂商</span> : </label>
        <el-select  size="small"   v-model="form.manufacturer" clearable  placeholder="请选择厂商" @change="changeManufacturer">
          <el-option
            v-for="(option, index) in manufacturer"
            :key="index"
            :label="option.manufacturer_name"
            :value="option.id">
          </el-option>
        </el-select>
      </div>






      <el-form :rules="tableRules" :model="recordInfo" ref="tableForm">
        <el-table :data="recordInfo.recordData" :class="signAndWeighBoxPatients" style="width: 100%" border
                  max-height="450" :header-cell-style="{ backgroundColor: 'rgb(245, 247, 250)'}"
        >


          <el-table-column min-width="35" align="center">

            <template slot="header" slot-scope="scope">
              <span>商品类型<span style="color: red">*</span></span>
            </template>

            <template slot-scope="scope">
              <el-form-item style="padding-top: 15px">
                <el-input placeholder="请输入商品类型" v-model="scope.row.good_type_id"
                          :value="typeName(scope.row.good_type_id)"
                          @focus="showDialog(scope.$index, scope.row)"></el-input>
              </el-form-item>
            </template>
          </el-table-column>
          <el-table-column min-width="35" align="center">
            <template slot="header" slot-scope="scope">
              <span>规格名称<span style="color: red">*</span></span>
            </template>
            <template slot-scope="scope">

              <el-form-item style="padding-top: 15px">
                <el-input placeholder="请输入规格名称" v-model="scope.row.good_id"
                          :value="specificationName(scope.row.good_id)"
                          @focus="showDialog(scope.$index, scope.row)"></el-input>
              </el-form-item>

            </template>
          </el-table-column>


          <el-table-column min-width="23" align="center">
            <template slot="header" slot-scope="scope">
              <span>退库数量<span style="color: red">*</span></span>
            </template>
            <template slot-scope="scope">
              <el-form-item :prop="'recordData.' + scope.$index + '.count'" :rules='tableRules.count'
                            style="padding-top: 17px">
                <el-input type="number" v-model="scope.row.count"></el-input>
              </el-form-item>
            </template>
          </el-table-column>

          <el-table-column label="操作" align="center" min-width="20">
            <template slot-scope="scope">
              <el-tooltip class="item" effect="dark" content="新增" placement="top">

                <el-button
                  size="mini"
                  type="primary"
                  icon="el-icon-circle-plus-outline"
                  @click="handleEdit(scope.$index, scope.row)">
                </el-button>
              </el-tooltip>
              <el-tooltip class="item" effect="dark" content="删除" placement="top">

                <el-button
                  size="mini"
                  type="danger"
                  icon="el-icon-delete"
                  @click="handleDelete(scope.$index, scope.row)">
                </el-button>
              </el-tooltip>

            </template>
          </el-table-column>


        </el-table>
      </el-form>

    </div>
  </div>

</template>

<script>
  import { uParseTime } from '@/utils/tools'

  import { deleteCancelStockInfo, editCancelStockInfo, getCancelStockConfig, getCancelStockInfo,GetAllGoodInfoByID,GetAllConfig  } from '@/api/stock'
  import BreadCrumb from '../components/bread-crumb'
  import StockInDialog from './Dialog/stockInDialog'

  export default {
    components: { StockInDialog, BreadCrumb },
    name: 'cancelStockOrderEdit',

    data() {
      return {
        crumbs: [
          { path: false, name: '库存管理' },
          { path: false, name: '耗材退库单' },
          { path: false, name: '编辑退库单' }
        ],

        crumbs2: [
          { path: false, name: '库存管理' },
          { path: false, name: '其他退库单' },
          { path: false, name: '编辑退库单' }
        ],


        signAndWeighBoxPatients: 'sign-and-weigh-box-patients',
        warehousing_time: '',
        adminUserOptions: null,
        currentIndex: 0,
        return_time: '',
        recordInfo: {
          recordData: [],
          stock_in_code: '',
          current_index: ''

        },
        tableRules: {
          count: [
            { required: true, message: '数量不能为空', trigge: 'blur' }
          ]

        },
        ruleForm: {
          manufacturer: [
            { required: true, message: '请选择厂商', trigger: 'change' }
          ]

        },

        // prop
        isVisibility: false,
        propForm: {
          goods: [],
          goodType: [],
          goodInfo: [],
          goodUnit: [],
          manufacturer: 0,
          dealer: 0
        },

        form: {
          manufacturer: '',
          dealer: ''
        },
        warehouseOutInfoList:[],
        cancelStock: {},
        manufacturer: [],
        dealer: [],
        goodType: [],
        goodInfo:[],
      }
    },
    methods: {
      comfirm: function(val) {
        this.$refs.dialog.hide()

        if (val.selectedGoodInfo.length > 0) {
          for (let i = val.selectedGoodInfo.length - 1; ; i--) {
            if (i == 0) {
              this.recordInfo.recordData[this.currentIndex].good_type_id = val.selectedGoodInfo[i].good_type_id
              this.recordInfo.recordData[this.currentIndex].good_id = val.selectedGoodInfo[i].id
            } else {
              const tempForm = {}
              tempForm['id'] = 0
              tempForm['good_type_id'] =val.selectedGoodInfo[i].good_type_id
              tempForm['good_id'] = val.selectedGoodInfo[i].id
              tempForm['count'] = ''
              this.recordInfo.recordData.splice(this.currentIndex + 1, 0, tempForm)
            }
          }
        }

        this.currentIndex = -1
      }, cancle: function() {
        this.$refs.dialog.hide()
      },
      GetConfigInfo: function() {
        const loading = this.$loading({
          lock: true,
          text: 'Loading',
          spinner: 'el-icon-loading',
          background: 'rgba(0, 0, 0, 0.7)'
        })

        GetAllConfig().then(response => {
          if (response.data.state == 0) {
            this.$message.error(response.data.msg)
            return false
          } else {
            this.manufacturer = response.data.data.manufacturer
            this.dealer = response.data.data.dealer
            this.goodType = response.data.data.goodType
            this.goodInfo = response.data.data.goodInfo
            this.manufacturer.splice(0, 0, { id: 0, manufacturer_name: '全部' })
            this.dealer.splice(0, 0, { id: 0, dealer_name: '全部' })
            this.manufacturer.splice(0, 0, { id: -1, manufacturer_name: '其他' })
            this.dealer.splice(0, 0, { id: -1, dealer_name: '其他' })
            this.form.manufacturer = 0
            this.form.dealer = 0
          }
          loading.close()
        })

      },

      typeName: function(good_type_id) {
        let name = ''
        for (let i = 0; i < this.goodType.length; i++) {
          if (this.goodType[i].id == good_type_id) {
            name = this.goodType[i].type_name
          }
        }
        return name
      },  specificationName: function(good_info_id) {
        let name = ''
        for (let i = 0; i < this.goodInfo.length; i++) {
          if (this.goodInfo[i].id == good_info_id) {
            name = this.goodInfo[i].specification_name
          }
        }
        return name
      }, handleEdit: function(index, row) {
        const tempObj = {}
        tempObj['id'] = 0
        tempObj['good_type_id'] = 0
        tempObj['good_id'] = 0
        tempObj['count'] = ''
        this.recordInfo.recordData.push(tempObj)
      }, handleDelete: function(index, row) {
        if (row.id == 0) {
          this.recordInfo.recordData.splice(index, 1)
        } else {
          const params = {
            id: row.id
          }
          this.$confirm('确认删除该退库商品信息记录?', '删除退库商品信息记录', {
            confirmButtonText: '确定',
            cancelButtonText: '取消',
            type: 'warning'
          }).then(() => {
            deleteCancelStockInfo(params).then(response => {
              if (response.data.state == 0) {
                this.$message.error(response.data.msg)
                return false
              } else {
                this.$message.success('删除成功')
                this.recordInfo.recordData.splice(index, 1)
              }
            })
          }).catch(() => {
          })
        }
      }, getTime(val, temp) {
        if (val != 0) {
          return uParseTime(val, temp)
        } else {
          return ''
        }
      },
      showDialog(index, row) {
        const loading = this.$loading({
          lock: true,
          text: 'Loading',
          spinner: 'el-icon-loading',
          background: 'rgba(0, 0, 0, 0.7)'
        })
        this.currentIndex = index
        this.isVisibility = true
        const params = {
          manufacturer_id: this.form.manufacturer,
          dealer_id: this.form.dealer
        }
        GetAllGoodInfoByID(params).then(response => {
            if (response.data.state == 0) {
              this.$message.error(response.data.msg)
              return false
              loading.close()

            } else {
              loading.close()

              if (response.data.data.goodInfo.length <= 0) {
                this.$message.error('该厂商或经销商没有物品信息')
                return
              }
              this.$refs.dialog.show()
              for (let i = 0; i < response.data.data.goodInfo.length; i++) {
                this.propForm.goodType.push(response.data.data.goodInfo[i].GoodsType)
              }
              const obj = {}
              this.propForm.goodType = this.propForm.goodType.reduce((cur, next) => {
                obj[next.id] ? '' : obj[next.id] = true && cur.push(next)
                return cur
              }, []) // 设置cur默认类型为数组，并且初始值为空的数组
            }

            for (let i = 0; i < this.propForm.goodType.length; i++) {
              let goodInfo = []
              let goodObj = {}

              for (let a = 0; a < response.data.data.goodInfo.length; a++) {
                var respObj = response.data.data.goodInfo[a]
                respObj['isSelected'] = false
                if (respObj.GoodsType.id == this.propForm.goodType[i].id) {
                  goodInfo.push(respObj)
                }
              }
              const obj = {}
              goodInfo = goodInfo.reduce((cur, next) => {
                obj[next.id] ? '' : obj[next.id] = true && cur.push(next)
                return cur
              }, []) // 设置cur默认类型为数组，并且初始值为空的数组

              this.$set(goodObj, this.propForm.goodType[i].id, goodInfo)
              this.propForm.goods.push(goodObj)
            }
          }
        )
      },

      back() {
        this.$router.go(-1)
      }, submit() {
        this.$refs['tableForm'].validate((valid) => {
          if (valid) {
            const array = this.recordInfo.recordData
            for (let i = 0; i < array.length; i++) {
              if (array[i].good_type_id == 0) {
                this.$message.error('商品类型不能为空')
                return
              }
              if (array[i].good_id == 0) {
                this.$message.error('规格名称不能为空')
                return
              }
            }

            const params = {
              'cancelStock': this.recordInfo.recordData
            }
            editCancelStockInfo(params, this.return_time, this.$route.query.id, this.$route.query.type,this.form.manufacturer,this.form.dealer).then(response => {
              if (response.data.state == 0) {
                this.$message.error(response.data.msg)
                return false
              } else {
                this.$message.success('退库成功')

                this.$router.back(-1)
              }
            })
          } else {
            return false
          }
        })
      }, GetOrderDetail: function(order_id) {
        const params = {
          'id': order_id
        }
        getCancelStockInfo(params).then(response => {
          if (response.data.state == 0) {
            this.$message.error(response.data.msg)
            return false
          } else {
            for (let i = 0; i < response.data.data.list.length; i++) {
              response.data.data.list[i].count = response.data.data.list[i].count.toString()
              this.recordInfo.recordData.push(response.data.data.list[i])
            }
            this.cancelStock = response.data.data.info
            this.return_time = this.getTime(this.cancelStock.return_time, '{y}-{m}-{d}')
            this.form.manufacturer = this.cancelStock.manufacturer
            this.form.dealer = this.cancelStock.dealer
          }
          if (this.recordInfo.recordData.length == 0) {
            const tempObj = {}
            tempObj['id'] = 0
            tempObj['good_type_id'] = 0
            tempObj['good_id'] = 0
            tempObj['count'] = ''
            this.recordInfo.recordData.push(tempObj)
          }
        })
      },changeManufacturer(val) {
        this.propForm.manufacturer = val
      },changeDealer(val){
        this.propForm.dealer = val
      }
    },
    created() {
      this.GetConfigInfo()
      this.propForm.goodUnit = this.$store.getters.good_unit
      const order_id = this.$route.query.id
      this.GetOrderDetail(order_id)
    }

  }
</script>

<style rel="stylesheet/css" lang="scss" scoped>
  .information {
    border: 1px #dcdfe6 solid;
    padding: 30px 20px 30px 20px;

  .border {
    border-bottom: 1px #dcdfe6 solid;
    margin: 0px 0 20px 0;
  }

  }



  .edit_separater {
    border-top: 1px solid rgb(233, 233, 233);
    margin-top: 15px;
    margin-bottom: 15px;
  }

</style>

<style>
  .sign-and-weigh-box .sign-and-weigh-box-patients .cell {
    font-size: 12px;
  }

  .sign-and-weigh-box .sign-and-weigh-box-patients .current-row > td {
    background: #6fb5fa;
  }

</style>
